Lattice Builder Manual Software Package for Constructing Rank-1 Lattices

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files
- Examples

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Friends Modules Pages
Public Member Functions | List of all members
LatBuilder::SizeParam< LatType::EMBEDDED > Class Template Reference

Lattice size type for embedded lattices. More...

`#include <SizeParam-EMBEDDED.h>`

Inherits LatBuilder::BasicSizeParam< SizeParam< LatType::EMBEDDED > >.

## Public Member Functions
| SizeParam (Modulus primeBase, Level maxLevel)
| Constructor. More...
| SizeParam (Modulus numPoints=0)
| Constructor. More...
template<class D >
| SizeParam (const BasicSizeParam< D > &other)
Modulus | base () const
| Returns the prime base for the number of points.
Level | maxLevel () const
| Returns the maximum embedding level of the base for the last lattice in the sequence.
Modulus | numPointsOnLevel (Level level) const
| Returns the number of points for the lattice at embedding level `level` in the sequence.
size_t | totient () const
void | normalize (Real &merit) const
void | normalize (RealVector &merit) const
| Divides the merit value at each level in `merit` by the number of points at that level.
std::ostream & | format (std::ostream &os) const
Public Member Functions inherited from LatBuilder::BasicSizeParam< SizeParam< LatType::EMBEDDED > >
| BasicSizeParam (Modulus numPoints)
Modulus | numPoints () const
| operator Modulus () const
size_t | totient () const
| Returns the value of Euler's totient function. More...
bool | operator== (const BasicSizeParam< D > &other) const
bool | operator!= (const BasicSizeParam< D > &other) const
bool | operator< (const BasicSizeParam< D > &other) const
void | normalize (Real &merit) const
| Divides the merit value `merit` by the number of points.
void | normalize (RealVector &merit) const
| Divides the each merit value in `merit` by the number of points.

## Additional Inherited Members
Protected Member Functions inherited from LatBuilder::BasicSizeParam< SizeParam< LatType::EMBEDDED > >
| BasicSizeParam (const BasicSizeParam &)=default

## Detailed Description

### template<>
class LatBuilder::SizeParam< LatType::EMBEDDED >

Lattice size type for embedded lattices.

Defining parameters:

- prime base for the number of points;
- maximum embedding level (power of the base for the last lattice in the sequence).

Examples:
  tutorial/FilteredCBC.cc, tutorial/LatDef.cc, tutorial/MeritSeqCoordUniform.cc, and tutorial/MeritSeqFastCBC.cc.

## Constructor & Destructor Documentation

LatBuilder::SizeParam< LatType::EMBEDDED >::SizeParam | ( | Modulus | primeBase,
|  | Level | maxLevel
| ) |  |

Constructor.

Parameters

  primeBase | Prime base for the number of points.
  maxLevel | The last lattice in the sequence (the one with the largest number of points) has \(\mathtt{primeBase}^{\mathtt{maxLevel}}\) points.

LatBuilder::SizeParam< LatType::EMBEDDED >::SizeParam | ( | Modulus | numPoints = `0` | ) |

Constructor.

Parameters

  numPoints | Number of points factorizable as an integer power of a prime base.

The documentation for this class was generated from the following file:

- latbuilder/include/latbuilder/SizeParam-EMBEDDED.h